# Unifying Back-Propagation and Forward-Forward Algorithms through Model Predictive Control

This repository is the official implementation of [Unifying Back-Propagation and Forward-Forward Algorithms through Model Predictive Control](https://openreview.net/forum?id=pui540SRjK&noteId=pui540SRjK). 

## Requirements

To install requirements:

```setup
pip install -r requirements.txt
```

## Data Generating

To get the data needed in the paper, run the following two notebooks [MPC_integrate.ipynb](./MPC_integrate.ipynb) and [MPC_finetune.ipynb](./MPC_finetune.ipynb)


## Ploting

(**Need data generated from training**) To get the plots in the paper, run [MPC_plot.ipynb](./MPC_plot.ipynb)

